local GameTooltip = GameTooltip

GameTooltip.factionIcon = GameTooltip:CreateTexture(nil, "ARTWORK")
GameTooltip.factionIcon:SetPoint("TOPRIGHT", 24, 6)
GameTooltip.factionIcon:SetSize(40, 40)

local function UnitTooltip(tooltip, data)
    if tooltip ~= GameTooltip then return end
    if not data then return end
    local _, unit = tooltip:GetUnit()
    if not unit then return end

    if UnitIsPlayer(unit) then
        local icon = "Interface\\TargetingFrame\\" .. "UI-PVP-" .. UnitFactionGroup(unit)
        GameTooltip.factionIcon:SetTexture(icon)
        GameTooltip.factionIcon:Show()
    end
end

GameTooltip:HookScript("OnTooltipCleared", function(self)
    self.factionIcon:SetTexture(nil)
    self.factionIcon:Hide()
end)

TooltipDataProcessor.AddTooltipPostCall(Enum.TooltipDataType.Unit, UnitTooltip)
